(*
Copyright 2011 Christian Sternagel, René Thiemann

This file is part of IsaFoR/CeTA.

IsaFoR/CeTA is free software: you can redistribute it and/or modify it under the
terms of the GNU Lesser General Public License as published by the Free Software
Foundation, either version 3 of the License, or (at your option) any later
version.

IsaFoR/CeTA is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License along
with IsaFoR/CeTA. If not, see <http://www.gnu.org/licenses/>.
*)
theory SN_Order_Carrier2
imports SN_Order_Carrier SN_Orders2
begin

instantiation rat :: poly_carrier
begin
instance ..
end

instantiation int :: poly_carrier
begin
instance ..
end

instantiation nat :: poly_carrier
begin
instance ..
end

instantiation arctic :: max_ordered_semiring_1
begin
definition max0_arctic :: "arctic \<Rightarrow> arctic" where [simp]: "max0_arctic \<equiv> id"
instance
proof
  fix x :: arctic
  show "x \<ge> 0" by (cases x, auto simp: zero_arctic_def)
next
  fix x :: arctic
  show "max0 x \<ge> x" by (cases x, auto)
qed auto
end

instantiation arctic_rat :: max_ordered_semiring_1
begin
definition max0_arctic_rat :: "arctic_rat \<Rightarrow> arctic_rat" where [simp]: "max0_arctic_rat \<equiv> id"
instance
proof
  fix x :: arctic_rat
  show "x \<ge> 0" by (cases x, auto simp: zero_arctic_rat_def)
next
  fix x :: arctic_rat
  show "max0 x \<ge> x" by (cases x, auto)
qed auto
end

lemma rat_poly: assumes dpos: "\<delta> > 0" and default: "\<delta> \<le> def"
  shows "poly_order_carrier def (rat_gt \<delta>) (1 \<le> \<delta>) False"
  by (rule poly_order_carrier.intro, rule rat_poly[OF assms])


end
